chiark / gitweb /
Update version in tg script to 0.5
[topgit.git] / tg.sh
diff --git a/tg.sh b/tg.sh
index e987561d3a2693159d2b88672839ec9cdb42bad3..2961106f735402d695043f31b32ffdef298566b3 100644 (file)
--- a/tg.sh
+++ b/tg.sh
@@ -20,13 +20,13 @@ die()
 # setup_hook NAME
 setup_hook()
 {
-       hook_call="\"\$(tg --hooks-path)\"/$1 \"\$@\""
+       hook_call="\"\$($tg --hooks-path)\"/$1 \"\$@\""
        if [ -f "$git_dir/hooks/$1" ] &&
           fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
                # Another job well done!
                return
        fi
-       # Prepare incanation
+       # Prepare incantation
        if [ -x "$git_dir/hooks/$1" ]; then
                hook_call="$hook_call"' || exit $?'
        else
@@ -45,11 +45,11 @@ setup_hook()
 # setup_ours (no arguments)
 setup_ours()
 {
-       if [ ! -s "$git_dir/info/gitattributes" ] || ! grep -q topmsg "$git_dir/info/gitattributes"; then
+       if [ ! -s "$git_dir/info/attributes" ] || ! grep -q topmsg "$git_dir/info/attributes"; then
                {
-                       echo -e ".topmsg\tmerge=ours"
-                       echo -e ".topdeps\tmerge=ours"
-               } >>"$git_dir/info/gitattributes"
+                       echo ".topmsg   merge=ours"
+                       echo ".topdeps  merge=ours"
+               } >>"$git_dir/info/attributes"
        fi
        if ! git config merge.ours.driver >/dev/null; then
                git config merge.ours.name '"always keep ours" merge driver'
@@ -60,11 +60,11 @@ setup_ours()
 # measure_branch NAME [BASE]
 measure_branch()
 {
-       _name="$1"; _base="$2"
-       [ -n "$_base" ] || _base="refs/top-bases/$_name"
+       _bname="$1"; _base="$2"
+       [ -n "$_base" ] || _base="refs/top-bases/$_bname"
        # The caller should've verified $name is valid
-       _commits="$(git rev-list "$_name" ^"$_base" | wc -l)"
-       _nmcommits="$(git rev-list --no-merges "$_name" ^"$_base" | wc -l)"
+       _commits="$(git rev-list "$_bname" ^"$_base" | wc -l)"
+       _nmcommits="$(git rev-list --no-merges "$_bname" ^"$_base" | wc -l)"
        if [ $_commits -gt 1 ]; then
                _suffix="commits"
        else
@@ -77,54 +77,113 @@ measure_branch()
 # Whether B1 is a superset of B2.
 branch_contains()
 {
-       [ -z "$(git rev-list ^"$1" "$2")" ]
+       [ -z "$(git rev-list ^"$1" "$2" --)" ]
 }
 
-# needs_update NAME [BRANCHPATH...]
+# ref_exists REF
+# Whether REF is a valid ref name
+ref_exists()
+{
+       git rev-parse --verify "$@" >/dev/null 2>&1
+}
+
+# has_remote BRANCH
+# Whether BRANCH has a remote equivalent (accepts top-bases/ too)
+has_remote()
+{
+       [ -n "$base_remote" ] && ref_exists "remotes/$base_remote/$1"
+}
+
+# recurse_deps CMD NAME [BRANCHPATH...]
+# Recursively eval CMD on all dependencies of NAME.
+# CMD can refer to $_name for queried branch name,
+# $_dep for dependency name,
+# $_depchain for space-seperated branch backtrace,
+# and the $_dep_is_tgish boolean.
+# It can modify $_ret to affect the return value
+# of the whole function.
+# If recurse_deps() hits missing dependencies, it will append
+# them to space-separated $missing_deps list and skip them.
+recurse_deps()
+{
+       _cmd="$1"; shift
+       _name="$1"; # no shift
+       _depchain="$*"
+
+       _depsfile="$(mktemp -t tg-depsfile.XXXXXX)"
+       # Check also our base against remote base. Checking our head
+       # against remote head has to be done in the helper.
+       if has_remote "top-bases/$_name"; then
+               echo "refs/remotes/$base_remote/top-bases/$_name" >>"$_depsfile"
+       fi
+       git cat-file blob "$_name:.topdeps" >>"$_depsfile"
+
+       _ret=0
+       while read _dep; do
+               if ! ref_exists "$_dep" ; then
+                       # All hope is lost
+                       missing_deps="$missing_deps $_dep"
+                       continue
+               fi
+
+               _dep_is_tgish=1
+               ref_exists "refs/top-bases/$_dep"  ||
+                       _dep_is_tgish=
+
+               # Shoo shoo, keep our environment alone!
+               [ -z "$_dep_is_tgish" ] ||
+                       (recurse_deps "$_cmd" "$_dep" "$@") ||
+                       _ret=$?
+
+               eval "$_cmd"
+       done <"$_depsfile"
+       missing_deps="${missing_deps# }"
+       rm "$_depsfile"
+       return $_ret
+}
+
+# branch_needs_update
+# This is a helper function for determining whether given branch
+# is up-to-date wrt. its dependencies. It expects input as if it
+# is called as a recurse_deps() helper.
+# In case the branch does need update, it will echo it together
+# with the branch backtrace on the output (see needs_update()
+# description for details) and set $_ret to non-zero.
+branch_needs_update()
+{
+       _dep_base_update=
+       if [ -n "$_dep_is_tgish" ]; then
+               if has_remote "$_dep"; then
+                       branch_contains "$_dep" "refs/remotes/$base_remote/$_dep" || _dep_base_update=%
+               fi
+               # This can possibly override the remote check result;
+               # we want to sync with our base first
+               branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_update=:
+       fi
+
+       if [ -n "$_dep_base_update" ]; then
+               # _dep needs to be synced with its base/remote
+               echo "$_dep_base_update $_dep $_depchain"
+               _ret=1
+       elif [ -n "$_name" ] && ! branch_contains "refs/top-bases/$_name" "$_dep"; then
+               # Some new commits in _dep
+               echo "$_dep $_depchain"
+               _ret=1
+       fi
+}
+
+# needs_update NAME
 # This function is recursive; it outputs reverse path from NAME
 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
 # inner paths first. Innermost name can be ':' if the head is
-# not in sync with the base.
+# not in sync with the base or '%' if the head is not in sync
+# with the remote (in this order of priority).
 # It will also return non-zero status if NAME needs update.
 # If needs_update() hits missing dependencies, it will append
 # them to space-separated $missing_deps list and skip them.
 needs_update()
 {
-       git cat-file blob "$1:.topdeps" 2>/dev/null | {
-               _ret=0
-               while read _dep; do
-                       if !git rev-parse --verify "$_dep" >/dev/null 2>&1; then
-                               # All hope is lost
-                               missing_deps="$missing_deps $_dep"
-                               continue
-                       fi
-
-                       _dep_is_tgish=1
-                       git rev-parse --verify "refs/top-bases/$_dep" >/dev/null 2>&1 ||
-                               _dep_is_tgish=
-
-                       # Shoo shoo, keep our environment alone!
-                       [ -z "$_dep_is_tgish" ] ||
-                               (needs_update "$_dep" "$@") ||
-                               _ret=$?
-
-                       _dep_base_uptodate=1
-                       if [ -n "$_dep_is_tgish" ]; then
-                               branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_uptodate=
-                       fi
-
-                       if [ -z "$_dep_base_uptodate" ]; then
-                               # _dep needs to be synced with its base
-                               echo ": $_dep $*"
-                               _ret=1
-                       elif ! branch_contains "refs/top-bases/$1" "$_dep"; then
-                               # Some new commits in _dep
-                               echo "$_dep $*"
-                               _ret=1
-                       fi
-               done
-               exit $_ret
-       }
+       recurse_deps branch_needs_update "$@"
 }
 
 # branch_empty NAME
@@ -146,16 +205,52 @@ switch_to_base()
        git symbolic-ref HEAD "$_base"
 }
 
+# Show the help messages.
+do_help()
+{
+       if [ -z "$1" ] ; then
+               ## Build available commands list for help output
+
+               cmds=
+               sep=
+               for cmd in "@cmddir@"/tg-*; do
+                       ! [ -r "$cmd" ] && continue
+                       # strip directory part and "tg-" prefix
+                       cmd="$(basename "$cmd")"
+                       cmd="${cmd#tg-}"
+                       cmds="$cmds$sep$cmd"
+                       sep="|"
+               done
+
+               echo "TopGit v0.5 - A different patch queue manager"
+               echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
+       elif [ -r "@cmddir@"/tg-$1 ] ; then
+               @cmddir@/tg-$1 -h || :
+               echo
+               if [ -r "@sharedir@/tg-$1.txt" ] ; then
+                       cat "@sharedir@/tg-$1.txt"
+               fi
+       else
+               echo "`basename $0`: no help for $1" 1>&2
+       fi
+}
+
 
 ## Initial setup
 
 set -e
 git_dir="$(git rev-parse --git-dir)"
 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
+# Make sure root_dir doesn't end with a trailing slash.
+root_dir="${root_dir%/}"
+base_remote="$(git config topgit.remote 2>/dev/null)" || :
+tg="tg"
 # make sure merging the .top* files will always behave sanely
 setup_ours
 setup_hook "pre-commit"
 
+[ -d "@cmddir@" ] ||
+       die "No command directory: '@cmddir@'"
 
 ## Dispatch
 
@@ -163,21 +258,26 @@ setup_hook "pre-commit"
 # this is set by hooks.
 [ -z "$tg__include" ] || return 0
 
+if [ "$1" = "-r" ]; then
+       shift; base_remote="$1"; shift
+       tg="$tg -r $base_remote"
+fi
+
 cmd="$1"
 [ -n "$cmd" ] || die "He took a duck in the face at two hundred and fifty knots"
 shift
 
 case "$cmd" in
-help)
-       echo "TopGit v0.1 - A different patch queue manager"
-       echo "Usage: tg (create|delete|info|patch|summary|update|help) ..."
+help|--help|-h)
+       do_help "$1"
        exit 1;;
-create|delete|info|patch|summary|update)
-       . "@cmddir@"/tg-$cmd;;
 --hooks-path)
        # Internal command
        echo "@hooksdir@";;
 *)
-       echo "Unknown subcommand: $cmd" >&2
-       exit 1;;
+       [ -r "@cmddir@"/tg-$cmd ] || {
+               echo "Unknown subcommand: $cmd" >&2
+               exit 1
+       }
+       . "@cmddir@"/tg-$cmd;;
 esac